	PAGE	,132
	NAME    EXAMPLES
;************
;
;	examplea.asm
;
;        䠩 ᮤন 樮 ணࠬ, ᯮ
;       CLIPPER-ᥬ 䥩.
;
;       㥬 㭪樨...
;
;		ISPRINTER()
;		TONE()
;		CURDIR()
;		BIN2I()
;		BIN2W()
;		BIN2L()
;		I2BIN()
;		L2BIN()
;
	INCLUDE	EXTENDA.INC


;***************
;
;       ।  ᥣ⮢
;
	CODESEG	EXAMPLEA
	DATASEG


;***************
;
;        㯭  㭪権
;
	CLpublic <ISPRINTER, TONE, CURDIR>
	CLpublic <BIN2I, BIN2W, BIN2L, I2BIN, L2BIN>


;***************
;
;       ᪨ 
;
	CLstatic <long nbuff 0>

        ;      㪠⥫   
	CLstatic <byte ASCIIZ <<64 DUP(0)>>, cptr PATH ASCIIZ>


;***************
;
;       
;

$define FALSE			0000H
$define TRUE			0001H

        ;  TONE()
$define TIMER_COMMAND           00B6H           ; 稭  ⠭ ⠩
$define TIMER_COMMAND_REGISTER  0043H           ;  
$define TIMER_LATCH_REGISTER    0042H           ;  
$define PORT_PB                 0061H           ;  
$define SPEAKER_ON              00000011B       ; ⮢ ᪠
$define CLOCK_RATE_HIGH         0012H           ; 1.19318    32 ⮢ ᫠
$define CLOCK_RATE_LOW		34DCH

        ;  CURDIR()
$define GET_CURDIR              0047H           ; DOS    DOS


;*******
;
;	ISPRINTER()
;	Tom Rettig, Brian Russell
;	11/01/85
;
;       :   ணࠬ ࠡ⠥ ⮫쪮  IBM-PC BIOS-ᮢ⨬ !
;
;       ᪮ "⨭", ᫨ ਭ 㯥  ⮢,  - "".
;
;	status = ISPRINTER()
;
;               status  -   ᪠ ६
;
;       ।  ᢮ ࠭ Tom Rettig Associates.
;
        ;  㭪樨
        ; 頥 ⨯   void, char, int, long, double, date,  log
	CLfunc log ISPRINTER

        ; 砫 
	CLcode
                MOV     AH, 02H                 ; 㭪 " ਭ"
                MOV     DX, 0                   ;  ਭ ஢
                INT     17H                     ; ⥭  ਭ

		MOV	BX, FALSE
                CMP     AH, 90H                 ; 90H 砥  
                JNE     ISPRINTER_RET           ;  "", ᫨ AH != 90H
		MOV	BX, TRUE

ISPRINTER_RET:
        ;  ᪮ 稭  Clipper (஢ "log" )
	CLret	BX


;******
;
;        䨪⨢ ᥣ    BIOS
;           ⮬ 
;
BIOS_DATA	SEGMENT AT 40H

		ORG	6CH
TIMER_LOW       LABEL   WORD                    ;  뢠 ६

BIOS_DATA	ENDS


;***************
;
;       砫 ᪨ ᥬ ணࠬ
;
	WORKFUNCS


;******
;
;       প   ⠩ "⨪". 稪 ⨪
;       ᮤন  DX ॣ,  ⨪ ࠢ 1/18 ᥪ㭤
;
TIME_DELAY	PROC	NEAR

                PUSH    ES                      ; ࠭


        ; ES = ᥣ   BIOS
                MOV     AX, BIOS_DATA           ; 㧪  ᥣ
		MOV	ES, AX

                ASSUME  ES:BIOS_DATA            ; (ᮮ饭 MASM  ES)


        ; প   祬  ⨪
                MOV     BX, TIMER_LOW           ; 㧪 ⥪饣 ६
T1:
                CMP     BX, TIMER_LOW           ; 横   TIMER_LOW
		JE	T1


        ; 横 প
T2:
                MOV     AX, TIMER_LOW           ; 㧪 ⥪饣 ६
                SUB     AX, BX                  ; AX = ⢮ 襤
                CMP     AX, DX                  ; ⨪ ࠢ  ॡ.
                JL      T2                      ; த. 横 ᫨ AX < DX


                POP     ES                      ; ⠭
                ASSUME  ES:NOTHING              ; (ᮮ. MASM  ᢮. ES)

                RET                             ;    /

TIME_DELAY	ENDP


;***************
;
;         ᥬ /
;
	ENDWORK


;******
;
;	TONE()
;	Dennis L. Dias
;	12/09/87
;
;       ந  㪠뢠   த⥫쭮. ᫨
;        < 20 , ⮣ 㧠  㪠 ॡ㥬 த⥫쭮
;
;       ।०:  / ࠡ⠥ ⮫쪮  IBM-PC ᮢ⨬ 㤮
;
;	TONE(frequency, duration)
;
;               frequency:      ᫮   --   ᥪ㭤
;               duration:       numeric -- 18- ⨪  ᥪ㭤
;
	CLfunc void TONE <int frequency, int duration>

	CLcode
                XOR     DX, DX                  ; প   ⨪
		CALL	TIME_DELAY

	; 1.19318 MHz / frequency
		MOV	BX, frequency
		CMP	BX, 20
		JB	SILENCE

        ; 롮 2-  ⠩; ⥭/ LSB  MSB; ० 3; 
		MOV	AL, TIMER_COMMAND
		OUT	TIMER_COMMAND_REGISTER, AL

		MOV	DX, CLOCK_RATE_HIGH
		MOV	AX, CLOCK_RATE_LOW

                DIV     BX                      ; AX = ⥫  

        ; 뢮 LSB, MSB (⠭ )
		OUT	TIMER_LATCH_REGISTER, AL
		MOV	AL, AH
		OUT	TIMER_LATCH_REGISTER, AL

        ; ࠭ ⥪饣 ०  pb
		IN	AL, PORT_PB
		PUSH	AX

        ;     ⠩஢
		OR	AL, SPEAKER_ON
		OUT	PORT_PB, AL

        ;  祭.. ॡ㥬 ६
		MOV	DX, duration
		CALL	TIME_DELAY

        ; 몫   祭
		POP	AX
		OUT	PORT_PB, AL

		JMP	SHORT TONE_RET

SILENCE:
        ;  প
		MOV	DX, duration
		CALL	TIME_DELAY

TONE_RET:

        ; 室   祭
	CLret


;******
;
;	CURDIR()
;	Dennis L. Dias
;	12/17/87
;
;       祭    㯠  ⥪饬 ⠫
;       ,   ப   訡,   ⮬,
;        ⥪騩 ⠫ - ୥.
;
;	string = CURDIR(drive)
;
;               drive:   㪢 ன⢠ (A, B, ...)
;                    :   ᫨ 饭 -  ⥪饥 ன⢮
;
	CLfunc char CURDIR <char drive>

	CLcode
                PUSH    DS                      ; ࠭
                LDS     SI, PATH                ; 㪠⥫    
                MOV     BYTE PTR [SI],0         ;  ப  砩 訡
                MOV     DL, 0                   ; । ⥪饥 ன⢮

                TESTNUL drive                   ; ஢ઠ, ।  ࠬ
		JZ	FILL_ASCIIZ

        ; ࠬ ।.. ᨬ
                PUSH    ES                      ; ࠭
                LES     BX, drive               ; 㧨 㪠⥫  ᥣ
                MOV     DL, ES:[BX]             ;  ᨬ
                AND     DL, 01011111B           ; 孨 ॣ
                SUB     DL, ('A' - 1)           ; ८ࠧ   ('A' = 1)
                POP     ES                      ; ⠭

FILL_ASCIIZ:
                DOSREQ  GET_CURDIR              ;    ⥬

                POP     DS                      ; ⠭

        ;  㪠⥫    ⠫
	CLret	PATH


;*******
;	BIN2I()
;       Bri  Richie
;
	CLfunc int BIN2I <char str>

	CLcode
		LES	BX, str
		MOV	AX, ES:[BX]

	CLret	AX


;*******
;	BIN2W()
;       Bri  Richie
;
	CLfunc long BIN2W <char str>

	CLcode
		LES	BX, str
		MOV	AX, ES:[BX]
		MOV	DX, 0

	CLret	DX AX


;*******
;	BIN2L()
;       Bri  Richie
;
	CLfunc long BIN2L <char str>

	CLcode
		LES	BX, str
		MOV	AX, ES:[BX]
		MOV	DX, ES:[BX+2]

	CLret	DX AX


;*******
;	I2BIN()
;       Bri  Richie
;
;       砭 -   , CL-   () ப,
;               ᮤঠ騥 㫥 , 㭪 ।  'void'
;                ᯮ ⥫ 맮 _retclen...
;
	CLfunc void I2BIN <int num>

	CLcode
		MOV	AX, num
		MOV	WORD PTR nbuff, AX

        ;  冷 ࠬ஢
		Ccall	_retclen <OFFSET(nbuff), SEG(nbuff), 2>

	CLret


;*******
;	L2BIN()
;       Bri  Richie
;
;       砭 -   , CL-   () ப,
;               ᮤঠ騥 㫥 , 㭪 ।  'void'
;                ᯮ ⥫ 맮 _retclen...
;
	CLfunc void L2BIN <long num>

	CLcode
		MOV	AX, LSW(num)
		MOV	DX, MSW(num)

		MOV	WORD PTR nbuff[0], AX
		MOV	WORD PTR nbuff[2], DX

        ;  冷 ࠬ஢
		Ccall	_retclen <OFFSET(nbuff), SEG(nbuff), 4>

	CLret


        ;  ᥬ୮ /
		END

;  examplea.asm
